package com.huasheng.quant.device;

import com.huasheng.quant.constant.ISystemError;
import com.huasheng.quant.request.DeviceBindRequst;
import com.huasheng.quant.utils.MobileValidator;
import com.huasheng.quant.vo.HttpResult;
import org.apache.commons.lang3.StringUtils;

import java.util.Map;
import java.util.Scanner;

public class DeviceBindApplication {

    public static void main(String[] args) {
        Scanner input = new Scanner(System.in);
        String mobile = null;
        String pk = null;
        String contryCode = null;
        String contryCodeMobile = null;
        String env = "2";//1:测试环境 2：开发环境
        for (int i = 0; i < 4; i++) {
            System.out.print("\r\n请选择连接环境(1：测试环境[测试环境无需绑定仅用于验证] 2：生产环境)：");
            env = input.nextLine();
            if (StringUtils.isBlank(env) || (!StringUtils.equals(env, "1") && !StringUtils.equals(env, "2"))) {
                System.out.println("\r\n请选择连接环境！！");
                continue;
            } else {
                break;
            }

        }
        for (int i = 0; i < 4; i++) {
            System.out.print("\r\n请输入开发者登录手机号(格式 CHN-18633336666)：");
            contryCodeMobile = input.nextLine();
            if (StringUtils.isNotBlank(contryCodeMobile)) {
                String[] contryCodeMobileArray = StringUtils.split(contryCodeMobile, "-");
                if (contryCodeMobileArray.length < 2) {
                    System.out.println("\r\n手机号码格式不正确！！!");
                    continue;
                }
                contryCode = contryCodeMobileArray[0];
                mobile = contryCodeMobileArray[1];
                if (!MobileValidator.isMobile(mobile, contryCode)) {
                    System.out.println("\r\n手机号码格式不正确！！!");
                    continue;
                }
                break;
            } else {
                System.out.println("\r\n请输入手机号码！！");
            }

        }

        for (int i = 0; i < 4; i++) {
            System.out.print("\r\n请输入开发者私钥[仅用于开发者身份签名验证]：");
            try {
                pk = input.nextLine();
                if (StringUtils.isNotBlank(pk)) {
                    HttpResult<Map<String, String>> result = DeviceBindRequst.sendAuthCode(contryCode, mobile, pk, env);
                    if (result.getRespCode().equals(ISystemError.SUCCESS.getCode())) {
                        System.out.println("\r\n验证码发送成功！");
                        break;
                    } else {
                        System.out.println("\r\n验证码发送失败！错误码：" + result.getRespCode() + " ");
                        //System.exit(0);
                    }
                } else {
                    System.out.println("\r\n手机号或秘钥不准确！");
                    //System.exit(0);
                }
            } catch (Exception e) {
                System.out.println("\r\n验证码发送失败！！请重试");
            }
        }


        for (int i = 0; i < 4; i++) {
            System.out.print("\r\n请输入手机验证码：");
            String code = input.nextLine();
            //System.out.println("接收到用户信息:"+mobile+"  验证码:"+code);
            if (code.length() > 0) {

                HttpResult<Map<String, String>> result = DeviceBindRequst.sendBindRequest(contryCode, mobile, code, pk, env);
                if (result.getRespCode().equals(ISystemError.SUCCESS.getCode())) {
                    System.out.println("\r\n绑定成功！");
                    break;
                } else {
                    System.out.println("\r\n绑定失败-请重试！错误码：" + result.getRespCode() + " ");
                    if (i == 3) {
                        System.out.println("\r\n错误次数过多请联系客服处理！错误码：" + result.getRespCode() + " " + result.getData());
                    }
                    //System.exit(0);
                }

            } else {
                System.out.print("输入参数不正确！");
                System.exit(0);
            }
        }
    }
}
